"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var AvoBatcher_1 = require("../AvoBatcher");
var AvoInspector_1 = require("../AvoInspector");
var AvoNetworkCallsHandler_1 = require("../AvoNetworkCallsHandler");
var AvoStorage_1 = require("../AvoStorage");
var constants_1 = require("./constants");
var inspectorVersion = process.env.npm_package_version || "";
describe("Batcher", function () {
    var checkBatchSpy;
    var inspectorCallSpy;
    var apiKey = constants_1.defaultOptions.apiKey, env = constants_1.defaultOptions.env, version = constants_1.defaultOptions.version, shouldLog = constants_1.defaultOptions.shouldLog;
    var storage = new AvoStorage_1.AvoStorage(shouldLog);
    var networkHandler = new AvoNetworkCallsHandler_1.AvoNetworkCallsHandler(apiKey, env, "", version, inspectorVersion);
    beforeAll(function () {
        checkBatchSpy = jest.spyOn(AvoBatcher_1.AvoBatcher.prototype, "checkIfBatchNeedsToBeSent");
        inspectorCallSpy = jest.spyOn(AvoNetworkCallsHandler_1.AvoNetworkCallsHandler.prototype, "callInspectorWithBatchBody");
    });
    afterEach(function () {
        jest.clearAllMocks();
        AvoInspector_1.AvoInspector.avoStorage.removeItem(AvoBatcher_1.AvoBatcher.cacheKey);
    });
    test("handleSessionStarted adds event to storage", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        inspector.avoBatcher.handleSessionStarted();
        var events = AvoInspector_1.AvoInspector.avoStorage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
        expect(events).not.toBeNull();
        if (events !== null) {
            expect(events.length).toEqual(1);
            expect(events[0].type === constants_1.networkCallType.SESSION_STARTED);
        }
    });
    test("handleTrackSchema adds event to storage", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        AvoInspector_1.AvoInspector.avoStorage.removeItem(AvoBatcher_1.AvoBatcher.cacheKey);
        inspector.avoBatcher.handleSessionStarted();
        inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
        var events = AvoInspector_1.AvoInspector.avoStorage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
        expect(events).not.toBeNull();
        if (events !== null) {
            expect(events.length).toEqual(2);
            expect(events[0].type === constants_1.networkCallType.SESSION_STARTED);
            expect(events[1].type === constants_1.networkCallType.EVENT);
        }
    });
    test("handleTrackSchema adds event to storage", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        AvoInspector_1.AvoInspector.avoStorage.removeItem(AvoBatcher_1.AvoBatcher.cacheKey);
        inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
        var events = AvoInspector_1.AvoInspector.avoStorage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
        expect(events).not.toBeNull();
        if (events !== null) {
            expect(events.length).toEqual(1);
            expect(events[0].type === constants_1.networkCallType.EVENT);
        }
    });
    test("checkIfBatchNeedsToBeSent is called on Batcher initialization", function () { return __awaiter(void 0, void 0, void 0, function () {
        var event;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    event = networkHandler.bodyForEventSchemaCall("name", [
                        { propertyName: "prop0", propertyType: "string" },
                    ], "testEventId", "testEventHash");
                    storage.setItem(AvoBatcher_1.AvoBatcher.cacheKey, [event]);
                    return [4 /*yield*/, new AvoBatcher_1.AvoBatcher(networkHandler)];
                case 1:
                    _a.sent();
                    expect(checkBatchSpy).toHaveBeenCalledTimes(1);
                    return [2 /*return*/];
            }
        });
    }); });
    test("checkIfBatchNeedsToBeSent is called on handleSessionStarted", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        inspector.avoBatcher.handleSessionStarted();
        expect(checkBatchSpy).toHaveBeenCalledTimes(1);
    });
    test("checkIfBatchNeedsToBeSent is called on handleTrackSchema", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        inspector.avoBatcher.handleSessionStarted();
        expect(checkBatchSpy).toHaveBeenCalledTimes(1);
    });
    test("Batcher saves events produced by AvoNetworkCallsHandler", function () { return __awaiter(void 0, void 0, void 0, function () {
        var schemaEvent, sessionEvent, inspector, events;
        return __generator(this, function (_a) {
            AvoInspector_1.AvoInspector.avoStorage.removeItem(AvoBatcher_1.AvoBatcher.cacheKey);
            schemaEvent = networkHandler.bodyForEventSchemaCall("name", [
                { propertyName: "prop0", propertyType: "string" },
            ], "testEventId", "testEventHash");
            sessionEvent = networkHandler.bodyForSessionStartedCall();
            inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
            inspector.enableLogging(false);
            inspector.avoBatcher.handleTrackSchema("name", [
                { propertyName: "prop0", propertyType: "string" },
            ], "testEventId", "testEventHash");
            inspector.avoBatcher.handleSessionStarted();
            events = storage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
            expect(events).not.toBeNull();
            if (events != null) {
                expect(events[0]).not.toBe(schemaEvent);
                expect(__assign(__assign({}, events[0]), { messageId: undefined, createdAt: undefined })).toStrictEqual(__assign(__assign({}, schemaEvent), { messageId: undefined, createdAt: undefined }));
                expect(events[1]).not.toBe(sessionEvent);
                expect(__assign(__assign({}, events[1]), { messageId: undefined, createdAt: undefined })).toStrictEqual(__assign(__assign({}, sessionEvent), { messageId: undefined, createdAt: undefined }));
            }
            return [2 /*return*/];
        });
    }); });
    test("Events are retrieved from Storage on init", function () {
        var getItemAsyncSpy = jest.spyOn(AvoStorage_1.AvoStorage.prototype, "getItemAsync");
        new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        expect(getItemAsyncSpy).toHaveBeenCalledTimes(1);
        expect(getItemAsyncSpy).toHaveBeenCalledWith(AvoBatcher_1.AvoBatcher.cacheKey);
    });
    test("Batch is not sent with batchSize - 1 events", function () {
        var eventCount = AvoInspector_1.AvoInspector.batchSize - 1;
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        __spreadArrays(Array(eventCount)).forEach(function () {
            inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
        });
        expect(checkBatchSpy).toHaveBeenCalledTimes(eventCount);
        expect(inspectorCallSpy).not.toHaveBeenCalled();
    });
    test("Batch is sent when event count matches batchSize", function () {
        var eventCount = AvoInspector_1.AvoInspector.batchSize;
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        __spreadArrays(Array(eventCount)).forEach(function () {
            inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
        });
        var events = storage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
        expect(checkBatchSpy).toHaveBeenCalledTimes(eventCount);
        expect(inspectorCallSpy).toHaveBeenCalledTimes(1);
        expect(inspectorCallSpy).toHaveBeenCalledWith(events, expect.any(Function));
    });
    test("Batch is sent only one time for batchSize + 1 events", function () {
        var eventCount = AvoInspector_1.AvoInspector.batchSize + 1;
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        var events = [];
        __spreadArrays(Array(eventCount)).forEach(function (_, i) {
            inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
            if (i === AvoInspector_1.AvoInspector.batchSize - 1) {
                events = storage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
            }
        });
        expect(checkBatchSpy).toHaveBeenCalledTimes(eventCount);
        expect(inspectorCallSpy).toHaveBeenCalledTimes(1);
        expect(inspectorCallSpy).toHaveBeenCalledWith(events, expect.any(Function));
        events = storage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
        expect(events.length).toBe(1);
    });
    test("Batch is not sent if batchFlushSeconds not exceeded", function () {
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        var now = new Date();
        var dateNowSpy = jest
            .spyOn(Date, "now")
            .mockImplementation(function () {
            return now.setMilliseconds(now.getMilliseconds() + (AvoInspector_1.AvoInspector.batchFlushSeconds - 1) * 1000);
        });
        inspector.avoBatcher.handleTrackSchema("event name", [], null, null);
        expect(checkBatchSpy).toHaveBeenCalledTimes(1);
        expect(inspectorCallSpy).not.toHaveBeenCalled();
        dateNowSpy.mockRestore();
    });
    test("Batch is sent if batchFlushSeconds exceeded", function () { return __awaiter(void 0, void 0, void 0, function () {
        var inspector, now, dateNowSpy, events;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
                    inspector.enableLogging(false);
                    now = new Date();
                    dateNowSpy = jest
                        .spyOn(Date, "now")
                        .mockImplementation(function () {
                        return now.setMilliseconds(now.getMilliseconds() + AvoInspector_1.AvoInspector.batchFlushSeconds * 1000);
                    });
                    return [4 /*yield*/, inspector.avoBatcher.handleTrackSchema("event name", [], null, null)];
                case 1:
                    _a.sent();
                    events = storage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
                    expect(checkBatchSpy).toHaveBeenCalledTimes(1);
                    expect(inspectorCallSpy).toHaveBeenCalledTimes(1);
                    expect(inspectorCallSpy).toHaveBeenCalledWith(events, expect.any(Function));
                    dateNowSpy.mockRestore();
                    return [2 /*return*/];
            }
        });
    }); });
    test("Only latest 1000 events are stored in the storage", function (done) {
        AvoInspector_1.AvoInspector.avoStorage.removeItem(AvoBatcher_1.AvoBatcher.cacheKey);
        var eventLimit = 1000;
        var events = [];
        for (var i = 0; i < eventLimit + 1; i++) {
            events.push(networkHandler.bodyForEventSchemaCall("event-name-" + i, [
                { propertyName: "prop0", propertyType: "string" },
            ], null, null));
        }
        AvoInspector_1.AvoInspector.avoStorage.setItem(AvoBatcher_1.AvoBatcher.cacheKey, events);
        var inspector = new AvoInspector_1.AvoInspector(constants_1.defaultOptions);
        inspector.enableLogging(false);
        setTimeout(function () {
            var setItemsSpy = jest.spyOn(AvoStorage_1.AvoStorage.prototype, "setItem");
            inspector.avoBatcher.handleSessionStarted();
            var savedEvents = AvoInspector_1.AvoInspector.avoStorage.getItem(AvoBatcher_1.AvoBatcher.cacheKey);
            expect(savedEvents).not.toBeNull();
            if (savedEvents !== null && savedEvents.length > 0) {
                events.push(savedEvents[savedEvents.length - 1]);
            }
            events.splice(0, 2);
            expect(setItemsSpy).toHaveBeenCalledTimes(1);
            expect(setItemsSpy).toHaveBeenCalledWith(AvoBatcher_1.AvoBatcher.cacheKey, events);
            done();
        }, 1000);
    });
});
