"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.trackingEndpoint = exports.type = exports.sessionTimeMs = exports.requestMsg = exports.networkCallType = exports.mockedReturns = exports.error = exports.defaultOptions = void 0;
var AvoInspectorEnv_1 = require("../AvoInspectorEnv");
var defaultOptions = {
    apiKey: "api-key-xxx",
    env: AvoInspectorEnv_1.AvoInspectorEnv.Prod,
    version: "1",
    shouldLog: true
};
exports.defaultOptions = defaultOptions;
var error = {
    API_KEY: "[Avo Inspector] No API key provided. Inspector can't operate without API key.",
    VERSION: "[Avo Inspector] No version provided. Many features of Inspector rely on versioning. Please provide comparable string version, i.e. integer or semantic.",
};
exports.error = error;
var mockedReturns = {
    INSTALLATION_ID: "avo-instalation-id",
    GUID: "generated-guid",
    SESSION_ID: "session-id",
};
exports.mockedReturns = mockedReturns;
var networkCallType = {
    EVENT: "event",
    SESSION_STARTED: "sessionStarted",
};
exports.networkCallType = networkCallType;
var requestMsg = {
    ERROR: "Request failed",
    TIMEOUT: "Request timed out",
};
exports.requestMsg = requestMsg;
var trackingEndpoint = "https://api.avo.app/inspector/v1/track";
exports.trackingEndpoint = trackingEndpoint;
var sessionTimeMs = 5 * 60 * 1000;
exports.sessionTimeMs = sessionTimeMs;
var type = {
    STRING: "string",
    INT: "int",
    OBJECT: "object",
    FLOAT: "float",
    LIST: "list",
    BOOL: "boolean",
    NULL: "null",
    UNKNOWN: "unknown",
};
exports.type = type;
